


import java.rmi.RemoteException;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import javax.xml.rpc.ServiceException;

import org.apache.axis.message.addressing.Address;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.URI.MalformedURIException;
import org.gcube.common.core.contexts.GCUBERemotePortTypeContext;
import org.gcube.common.core.contexts.GHNContext;
import org.gcube.common.core.faults.GCUBEUnrecoverableFault;
import org.gcube.common.core.scope.GCUBEScope;
import org.gcube.common.core.scope.GCUBEScope.MalformedScopeExpressionException;
import org.gcube.common.core.security.GCUBESecurityManagerImpl;
import org.gcube.textextraction.stubs.CreateResource;
import org.gcube.textextraction.stubs.CreateResourceResponse;
import org.gcube.textextraction.stubs.Start;
import org.gcube.textextraction.stubs.TextExtractionJobControllerFactoryPortType;
import org.gcube.textextraction.stubs.TextExtractionJobControllerPortType;
import org.gcube.textextraction.stubs.service.TextExtractionJobControllerFactoryServiceAddressingLocator;
import org.gcube.textextraction.stubs.service.TextExtractionJobControllerServiceAddressingLocator;
import org.gcube.common.core.informationsystem.ISException;
import org.gcube.common.core.informationsystem.client.AtomicCondition;
import org.gcube.common.core.informationsystem.client.ISClient;
import org.gcube.common.core.informationsystem.client.ISClient.ISMalformedQueryException;
import org.gcube.common.core.informationsystem.client.RPDocument;
import org.gcube.common.core.informationsystem.client.ISClient.ISUnsupportedQueryException;
import org.gcube.common.core.informationsystem.client.queries.WSResourceQuery;
import org.apache.axis.message.addressing.EndpointReference;


public class TextExtractionClient {

	
	static ISClient client = null;
	
	static String scope = "/gcube/devNext";
	/**
	 * @param args
	 */
	public static void main(String[] args)  {
		try {
			execute(1);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	private static void execute(int number) throws Exception {
		GCUBESecurityManagerImpl secManager = new GCUBESecurityManagerImpl() {  public boolean isSecurityEnabled() {return false;}};
		if (number == 1) {
			// Create resource
			String factoryURI = null;
						
				// Get factory portType
		    	TextExtractionJobControllerFactoryServiceAddressingLocator factoryLocator = new TextExtractionJobControllerFactoryServiceAddressingLocator();
		    	EndpointReferenceType textExtractionFactoryEPR = new EndpointReferenceType();
		    	try {
					textExtractionFactoryEPR.setAddress(new Address("http://dl09.di.uoa.gr:8576/wsrf/services/gcube/textextraction/TextExtractionJobControllerFactory"));
				} catch (MalformedURIException e3) {
					// TODO Auto-generated catch block
					e3.printStackTrace();
				}
		    	TextExtractionJobControllerFactoryPortType factoryPortType = null;
				try {
					factoryPortType = factoryLocator.getTextExtractionJobControllerFactoryPortTypePort(textExtractionFactoryEPR);
				} catch (ServiceException e2) {
					// TODO Auto-generated catch block
					e2.printStackTrace();
				}
		        try {
					factoryPortType = GCUBERemotePortTypeContext.getProxy(factoryPortType, GCUBEScope.getScope(scope), secManager);
				} catch (MalformedScopeExpressionException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (Exception e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
		        
		        // Create the IncrementalIndexUpdater resource
		       // Create the IncrementalIndexUpdater resource
		        CreateResource createResourceReq = new CreateResource();
		        createResourceReq.setDTSInputCollectionID("testingDTSInputColId");
		        createResourceReq.setFTPLocationDirectory("/home/rena/dir");
		        createResourceReq.setQueryToSubmit("((((882bcfc4-c756-42e1-b0d4-32bfb6be03a3 = textual) and (gDocCollectionID == b4ba3a10-b47d-11e0-9e5d-fda94ff03826)) and (mplampla = <startPage>)) and (mploumplou = <size>)) project 438fe479-2479-436a-ae56-be2a30c25792 79697524-e3bf-457b-891a-faa3a9b0385f ead6f5a8-d8e6-40fd-afd2-ffcec3b042d0 ee178c1e-05e0-4c0b-bd74-29da46d164d5");
		        createResourceReq.setRepositoryID("testingRepositoryId8");
		        createResourceReq.setServletURI("testingServletURI");
		        createResourceReq.setRepositoryNumberOfRecords(16000);	// create 15 jobs
		        createResourceReq.setFTPHost("fake.host.di.uoa.gr");


		        try {
					CreateResourceResponse response = factoryPortType.createResource(createResourceReq);
				} catch (GCUBEUnrecoverableFault e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (RemoteException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		        
		        System.out.println("Resource successfully created.");
		} else if (number == 2) {
			// start
			LinkedList<AtomicCondition> wsPropDocACs = new LinkedList<AtomicCondition>();
			wsPropDocACs.add(new AtomicCondition("//child::*[local-name()='ServiceName']", "TextExtractionJobController"));
			wsPropDocACs.add(new AtomicCondition("//child::*[local-name()='ServiceClass']", "TextExtraction"));
			wsPropDocACs.add(new AtomicCondition("//child::*[local-name()='RepositoryID']", "testingRepositoryId8"));
			
			
			if(client == null)
			{
				try {
					client = GHNContext.getImplementation(ISClient.class);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			

			WSResourceQuery wsquery = null;
			try {
				wsquery = client.getQuery(WSResourceQuery.class);
			} catch (ISUnsupportedQueryException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (InstantiationException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (IllegalAccessException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}

			for (AtomicCondition ac : wsPropDocACs)
				wsquery.addAtomicConditions(ac);
			System.out.println("EPR query: " + wsquery.getExpression());
			List<RPDocument> rp = null;
			try {
				rp = client.execute(wsquery, GCUBEScope.getScope(scope));
			} catch (MalformedScopeExpressionException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ISMalformedQueryException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ISUnsupportedQueryException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ISException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			System.out.println("Number of results " + rp.size());
			EndpointReferenceType epr = null;
			if(rp.size() == 0) {
				throw new Exception("Could not find a WS resource for these criteria");
			}
			for (RPDocument rpd : rp) {
				epr = rpd.getEndpoint();
			}
			TextExtractionJobControllerServiceAddressingLocator tejcAL = new TextExtractionJobControllerServiceAddressingLocator();
			TextExtractionJobControllerPortType port = null;
			port = tejcAL.getTextExtractionJobControllerPortTypePort(epr);
			
			port = GCUBERemotePortTypeContext.getProxy(port, GCUBEScope.getScope(scope), secManager);
			port.start(new Start());
			System.out.println("**************************************************");
		}
	}

}
